{-|
Module      : EPO.API.Client.Implementation
Description : EPO Patents database crawler (API client)
Copyright   : (c) CNRS, 2023-present
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX
-}

module EPO.API.Client.Implementation
  ( searchEPOAPI
  )
where

import EPO.API.Client
import EPO.API.Client.Types
import Network.URI qualified as URI
import Protolude
import Servant.Client (runClientM)


searchEPOAPI :: URI.URI
             -> AuthKey
             -> Start
             -> End
             -> Search
             -> IO HyperdataDocuments
searchEPOAPI uri auth start end search' = do
  env <- defaultClientEnv uri
  eRes <- runClientM (search (Just auth) (Just start) (Just end) (Just search')) env
  case eRes of
    Left err-> throwIO err
    Right res -> pure res
